<template>
  <div class="book-container">
    <div>
      <object
        :data="`https://covers.openlibrary.org/b/olid/${book.cover_edition_key}-L.jpg`"
        type="image/jpeg"
      >
        <img src="@/assets/img/cover404.png" />
      </object>
    </div>
    <div class="book-details">
      <h2>{{ book.title }}</h2>
      <p>
        <em>{{ book.subtitle }}</em>
      </p>
      <p v-if="book.first_sentence">
        &ldquo;{{
          book.first_sentence?.sort((a, b) => b.length - a.length)[0]
        }}&rdquo;
      </p>
      <p>
        <span
          v-for="(subject, i) in book.subject?.filter((b, i) => i < 5)"
          :key="i"
          class="chip"
        >
          {{ subject }}
        </span>
      </p>
      <p>
        First published {{ book.first_publish_year }} ({{ book.edition_count }}
        editions)
      </p>
      <p><strong>Publisher:</strong> {{ book.publisher?.[0] }}</p>
      <div class="author-panel">
        <h3>Author{{ book.author_name?.length > 1 ? 's' : '' }}:</h3>
        <div class="flex wrapped">
          <AuthorThumb
            v-for="(authorName, i) in book.author_name"
            :key="i"
            :author-key="book.author_key?.[i]"
            :author-name="authorName"
          />
        </div>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { computed } from 'vue'
import { useSearchStore } from '@/stores/search'
import AuthorThumb from './AuthorThumb.vue'

const searchStore = useSearchStore()

const book = computed(() => searchStore.currentBook)
</script>

<style scoped>
.book-container {
  display: flex;
  flex-direction: column;
}
.book-details {
  margin-left: 0;
}
.book-details > p {
  margin-top: 10px;
}
.chip {
  border-radius: 100px;
  background-color: #1113;
  padding: 10px;
  text-transform: uppercase;
  font-size: 0.7rem;
  display: inline-block;
  margin-right: 5px;
}
.author-panel {
  margin-top: 20px;
  padding-top: 10px;
  border-top: 1px solid #7773;
}
@media screen and (min-width: 768px) {
  .book-container {
    flex-direction: row;
  }
  .book-details {
    margin-left: 20px;
  }
}
</style>
